﻿using System.Collections.Generic;
using GCHR.Model.Konto;

namespace GCHR.Control.Tasks
{
    class UebersetzungStat : Uebersetzung
    {
        public UebersetzungStat(int id, string name)
            : base(id, name)
        {
            Dateiname = "uebersetzungstabelle_stat.csv";
            KontoTyp = KontoTypen.Stat;
        }

        protected override void TabelleUebergeben(Dictionary<string, string> uebersetzung)
        {
            Data.SetUebersetzungStat(uebersetzung);
        }

        protected override bool ManuellesKonto(string kontonummer)
        {
            var konto = Config.ManuellesKontoSuchen(kontonummer);
            return Data.AddManStatKonto(konto);
        }
    }
}
