﻿using System;
using System.Text.RegularExpressions;
using GCHR.Model;
using GCHR.Model.Konto;

namespace GCHR.Mandantenschnittstelle
{
    class Citroen : IMandant
    {
        private readonly Konfiguration _config = Konfiguration.GetInstance();

        public bool BalanceDatei
        {
            get
            {
                return true;
            }
        }

        public bool AccountsDatei
        {
            get
            {
                return false;
            }
        }

        public string BalanceHeader
        {
            get
            {
                return String.Format("01{0}{1}{2}{3}", _config.Händlernummer.PadLeft(7, '0'), _config.Eurodatanummer, HaendlerKonto.AktuellePeriode.Monat, HaendlerKonto.AktuellePeriode.JahrZweistellig);
            }
        }

        public string BalanceFooter
        {
            get
            {
                return String.Empty;
            }
        }

        public string BalanceBody(HaendlerKonto kto)
        {
            return ("02" + kto +
                        Regex.Replace(String.Format("{0:0.00+;0.00+;0.00+}", kto.Soll), ",", "").PadLeft(13, '0') +
                        Regex.Replace(String.Format("{0:0.00+;0.00+;0.00+}", kto.Haben), ",", "").PadLeft(13, '0') +
                        "000000000000+" + "000000000000+");
        }

        public string AccountsHeader
        {
            get
            {
                return String.Empty;
            }
        }

        public string AccountsFooter
        {
            get
            {
                return String.Empty;
            }
        }

        public string AccountsBody(HaendlerKonto kto)
        {
            return String.Empty;
        }
    }
}
