﻿using System;
using GCHR.Model;
using GCHR.Model.Konto;

namespace GCHR.Mandantenschnittstelle
{
    /**
     * <summary>Im Vergleich zu Opel wird bei Fiat im BalanceHeader das "M" weggelassen und die Salden mit Komma getrennt.</summary>
     */
    class Fiat : IMandant
    {
        private readonly Konfiguration _config = Konfiguration.GetInstance();

        public bool BalanceDatei
        {
            get
            {
                return true;
            }
        }

        public bool AccountsDatei
        {
            get
            {
                return true;
            }
        }

        public string BalanceHeader
        {
            get
            {
                return String.Format("AA{0} {1}{2} ,20EUR", _config.Händlernummer, HaendlerKonto.AktuellePeriode.Monat, HaendlerKonto.AktuellePeriode.JahrZweistellig);
            }
        }

        public string BalanceFooter
        {
            get
            {
                return String.Format("XX{0} {1}{2}", _config.Händlernummer, HaendlerKonto.AktuellePeriode.Monat, HaendlerKonto.AktuellePeriode.JahrZweistellig);
            }
        }

        public string BalanceBody(HaendlerKonto kto)
        {
            return (kto + String.Format("{0,30:0.00}", (kto.Summe)));
        }

        public string AccountsHeader
        {
            get
            {
                return "Account Code".PadRight(42, ' ') + "Description";
            }
        }

        public string AccountsFooter
        {
            get
            {
                return String.Empty;
            }
        }

        public string AccountsBody(HaendlerKonto kto)
        {
            return (kto.ToString().PadRight(42, ' ') + kto.Bezeichnung);
        }
    }
}
