﻿using System;
using GCHR.Model;
using GCHR.Model.Konto;

namespace GCHR.Mandantenschnittstelle
{
    class Honda : IMandant
    {
        protected Konfiguration Config = Konfiguration.GetInstance();

        public bool BalanceDatei
        {
            get
            {
                return true;
            }
        }

        public bool AccountsDatei
        {
            get
            {
                return false;
            }
        }

        public string BalanceHeader
        {
            get
            {
                return
                    string.Format(
                        "{1};Dealernumber{0};Honda Germany{0}{2};Evaluation;{3}{0}{4};Fiscal-Year;{5}{0};Timestamp;{6}",
                        Environment.NewLine, Config.Händlernummer, HaendlerKonto.AktuellePeriode.Jahr,
                        HaendlerKonto.AktuellePeriode.Monat,
                        HaendlerKonto.AktuellePeriode.Jahresbeginn(Config.Geschaeftsjahr).Jahr,
                        HaendlerKonto.AktuellePeriode.Jahresbeginn(Config.Geschaeftsjahr).Monat,
                        DateTime.Now.ToString("MMddyyyy;HHmmss"));
            }
        }

        public string BalanceFooter
        {
            get
            {
                return string.Empty;
            }

        }

        public string BalanceBody(HaendlerKonto kto)
        {
            return (string.Format("{0};{1};{2};{3}", Kontonummer(kto), kto.Bezeichnung, kto.SummeAktuellePeriode, kto.Summe).Replace(',', '.'));
        }

        private static string Kontonummer(HaendlerKonto kto)
        {
            return kto.Kontonummer.Substring(0, 4) + kto.Marke + kto.Betrieb + kto.Kontonummer.Substring(4);
        }

        public string AccountsHeader
        {
            get
            {
                return string.Empty;
            }
        }

        public string AccountsFooter
        {
            get
            {
                return string.Empty;
            }

        }

        public string AccountsBody(HaendlerKonto kto)
        {
            return string.Empty;
        }
    }
}
