﻿using System;
using GCHR.Model;
using GCHR.Model.Konto;

namespace GCHR.Mandantenschnittstelle
{
    class Opel : IMandant
    {
        protected Konfiguration Config = Konfiguration.GetInstance();

        public bool BalanceDatei
        {
            get
            {
                return true;
            }
        }

        public bool AccountsDatei
        {
            get
            {
                return true;
            }
        }

        public string BalanceHeader
        {
            get
            {
                return String.Format("AA{0}M{1}{2} .20EUR", Config.Händlernummer, HaendlerKonto.AktuellePeriode.Monat, HaendlerKonto.AktuellePeriode.JahrZweistellig);
            }
        }

        public string BalanceFooter
        {
            get
            {
                return String.Format("XX{0}M{1}{2}", Config.Händlernummer, HaendlerKonto.AktuellePeriode.Monat, HaendlerKonto.AktuellePeriode.JahrZweistellig);
            }

        }

        public string BalanceBody(HaendlerKonto kto)
        {
            return (kto + String.Format("{0,30:0.00}", (kto.Summe)).Replace(',', '.'));
        }


        public string AccountsHeader
        {
            get
            {
                return "Account Code".PadRight(42, ' ') + "Description";
            }
        }

        public string AccountsFooter
        {
            get
            {
                return String.Empty;
            }

        }

        public string AccountsBody(HaendlerKonto kto)
        {
            return (kto.ToString().PadRight(42, ' ') + kto.Bezeichnung);
        }
    }
}
