﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using GCHR.Model.Konto;

namespace GCHR.Model.Uebersetzung
{
    class KontoNichtZugeordnetException : NullReferenceException
    {
        public KontoNichtZugeordnetException(HaendlerKonto haendlerKonto)
            : base(haendlerKonto.DebugInfo())
        {
        }

        public KontoNichtZugeordnetException(string haendlerKontonummer)
            : base(haendlerKontonummer)
        {
        }
    }

    class HerstellerkontoNichtVorhandenException : NullReferenceException
    {
        public HerstellerkontoNichtVorhandenException(HaendlerKonto haendlerKonto, string herstellerKontonummer)
            : base(haendlerKonto.DebugInfo() + " => " + herstellerKontonummer)
        {
        }

        public HerstellerkontoNichtVorhandenException(string herstellerKontonummer)
            : base(herstellerKontonummer)
        {
        }
    }

    class UebersetzungNichtVorhandenException : NullReferenceException
    {
        public UebersetzungNichtVorhandenException(HaendlerKonto haendlerKonto)
            : base(haendlerKonto.DebugInfo())
        {
        }

        public UebersetzungNichtVorhandenException(string haendlerKontonummer)
            : base(haendlerKontonummer)
        {
        }
    }

    class HerstellerkontoTypArgumentException : ArgumentException
    {
        public HerstellerkontoTypArgumentException(HaendlerKonto haendlerKonto, string herstellerKontonummer)
            : base(haendlerKonto.DebugInfo() + " => " + herstellerKontonummer)
        {
        }

        public HerstellerkontoTypArgumentException(string herstellerKontonummer)
            : base(herstellerKontonummer)
        {
        }
    }
}
