﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace GCHR.Model.Uebersetzung
{
    class HerstellerKontenrahmen
    {
        private Dictionary<string, HerstellerKonto> kontenrahmen = new Dictionary<string, HerstellerKonto>();

        public HerstellerKontenrahmen(StreamReader sr)
        {
            while (!sr.EndOfStream)
            {
                HerstellerKonto kto = new HerstellerKonto(sr.ReadLine());
                while (kontenrahmen.ContainsKey(kto.Kontonummer))
                {
                    kto.Kontonummer += "X";
                }
                kontenrahmen.Add(kto.Kontonummer, kto);
            }
        }

        public void Speichern(StreamWriter sw)
        {
            foreach (HerstellerKonto kto in kontenrahmen.Values)
            {
                sw.WriteLine(kto);
            }
        }

        public bool Contains(string kontonummer)
        {
            return kontenrahmen.ContainsKey(kontonummer);
        }

        public HerstellerKonto Get(string kontonummer)
        {
            return kontenrahmen[kontonummer];
        }



    }
}
